//+------------------------------------------------------------------+
//|                                            Virtual_Tral_Stop.mq4 |
//|                                     Copyright  2009, metaquotes |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, metaquotes"
#property link      "http://www.metaquotes.net"

//---- input parameters

extern string   Symbols         = "-1";        
extern int      Magic           = -1;          
extern string   Comments        = "-1";        
extern int      Set_Y           = 20;          //   
extern int      Set_X           = 50;           //   
extern double   updatesecond    = 0.3;         //   

double CurrentProfitAll;
//-------    -------------------------------------------
#include <stdlib.mqh>
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
   ObjectDelete("1");
   ObjectDelete("2");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {while (IsExpertEnabled())
    {Sleep (1000*updatesecond);
     RefreshRates(); 
     
     //Comment(" Comment   ?!");
     
     CurrentProfitAll  = GetProfitOpenPosInCurrency("", -1, Magic, Comments);
     SetLabel("1", DoubleToStr(CurrentProfitAll,2), "Arial Black",Red, Set_X, Set_Y, 1, 10);
     SetLabel("2", "CurrentProfit", "Arial Black",Red, Set_X+80, Set_Y, 1, 10);
    }
   return(0);
  }
//+----------------------------------------------------------------------------+
//  .
//+----------------------------------------------------------------------------+
double GetProfitOpenPosInCurrency(string sy, int op, int mn ,string comm) {
  double p, pr=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if ((mn<0 || OrderMagicNumber()==mn)&&(comm=="-1" || OrderComment()==comm)) {
          p=MarketInfo(OrderSymbol(), MODE_POINT);
          if (p==0) if (StringFind(OrderSymbol(), "JPY")<0) p=0.0001; else p=0.01;
          if (OrderType()==OP_BUY) {
            pr+=OrderProfit()+OrderCommission()+OrderSwap();//
          }
          if (OrderType()==OP_SELL) {
            pr+=OrderProfit()+OrderCommission()+OrderSwap();//
          }
        }
      }
    }
  }
  return(pr);
}
//+----------------------------------------------------------------------------+
void SetLabel(string nm, string tx, string font_name,color cl, int xd, int yd, int cr=0,  int fs=9) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx, fs, font_name);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
}
//+----------------------------------------------------------------------------+